<?php if ( ! defined( 'ABSPATH' ) ) exit;

/*
Plugin Name: paystar-card-payment-for-edd
Plugin URI: https://paystar.ir
Description: paystar-card-payment-for-edd
Version: 1.0
Author: ماژول بانک
Author URI: https://www.modulebank.ir
Text Domain: paystar-card-payment-for-edd
Domain Path: /languages
 */

load_plugin_textdomain('paystar-card-payment-for-edd', false, basename(dirname(__FILE__)) . '/languages');
__('paystar-card-payment-for-edd', 'paystar-card-payment-for-edd');

function edd_add_gateway_paystar_card($gateways)
{
	return array_merge($gateways, array(
				'paystar_card' => array(
					'admin_label'    => __('PayStar Card', 'paystar-card-payment-for-edd'),
					'checkout_label' => __('PayStar Card', 'paystar-card-payment-for-edd'),
					'supports'       => array('buy_now')
				)
			)
		);
}
add_filter('edd_payment_gateways', 'edd_add_gateway_paystar_card');

function edd_send_to_gateway_paystar_card($purchase_data)
{
	global $edd_options;
	$payment_data = array(
			'price'        => $purchase_data['price'], 
			'date'         => $purchase_data['date'], 
			'user_email'   => $purchase_data['post_data']['edd_email'],
			'purchase_key' => $purchase_data['purchase_key'],
			'currency'     => $edd_options['currency'],
			'downloads'    => $purchase_data['downloads'],
			'cart_details' => $purchase_data['cart_details'],
			'user_info'    => $purchase_data['user_info'],
			'status'       => 'pending'
		);
	if ($payment = edd_insert_payment($payment_data))
	{
		echo '<div id="paystar-wc-wait" style="position:fixed; width:100%; height:100%; left:0; top:0; z-index:9999; opacity:0.90; -moz-opacity:0.90; filter:alpha(opacity=90); background-color:#fff;">
				<img src="' . esc_url(plugin_dir_url(__FILE__)) . 'images/wait.gif" style="position:fixed; left:50%; top:50%; width:466px; height:368px; margin:-184px 0 0 -233px;" />
			</div>';
		require_once(dirname(__FILE__) . '/paystar_card_payment_helper.class.php');
		$p = new PayStarCard_Payment_Helper($edd_options['paystar_card_terminal']);
		$r = $p->paymentRequest(array(
				'amount'       => intval(ceil($purchase_data['price'])),
				'order_id'     => $payment . '-' . time(),
				'callback_url' => add_query_arg(array('listener' => 'paystar-card-edd',  'paymentId' => $payment, 'ed' => 0), get_permalink($edd_options['success_page'])),
				'token'        => $edd_options['paystar_card_terminal']
			));
		if ($r)
		{
			update_post_meta($payment, 'paystar_card_token', $r->token);
			session_write_close();
			echo '<form name="frmPayStarCardPayment" method="get" action="https://card.paystar.ir/check"><input type="hidden" name="token" value="'.esc_html($r->token).'" />';
			echo '<input class="paystar_btn btn button" type="submit" value="'.__('Pay', 'paystar-card-payment-for-edd').'" /></form>';
			echo '<script>document.frmPayStarCardPayment.submit();</script>';
		}
		else
		{
			echo esc_html($p->error) . '<script>document.getElementById("paystar-wc-wait").style.display="none";</script>';
		}
		exit;
	}
	else
	{
		edd_send_back_to_checkout('?payment-mode='.$purchase_data['post_data']['edd-gateway']);
	}
}
add_action('edd_gateway_paystar_card', 'edd_send_to_gateway_paystar_card');

function edd_gateway_paystar_card_verify()
{
	if (isset($_GET['listener']) && $_GET['listener'] == 'paystar-card-edd')
	{
		global $edd_options;
		if (isset($_GET['amp;order_id'])) {
			list($paymentId, $nothing) = explode('-', sanitize_text_field($_GET['amp;order_id']));
		} elseif (isset($_GET['order_id'])) {
			list($paymentId, $nothing) = explode('-', sanitize_text_field($_GET['order_id']));
		} elseif (isset($_GET['amp;paymentId'])) {
			$paymentId = sanitize_text_field($_GET['amp;paymentId']);
		} elseif (isset($_GET['paymentId'])) {
			$paymentId = sanitize_text_field($_GET['paymentId']);
		}
		if (isset($_GET['amp;hashid'])) {
			$hashid = sanitize_text_field($_GET['amp;hashid']);
		} elseif (isset($_GET['hashid'])) {
			$hashid = sanitize_text_field($_GET['hashid']);
		}
		$amount = intval(ceil(edd_get_payment_amount($paymentId)));
		require_once(dirname(__FILE__) . '/paystar_card_payment_helper.class.php');
		$p = new PayStarCard_Payment_Helper($edd_options['paystar_card_terminal']);
		$r = $p->paymentVerify($x = array(
				'hashid' => $hashid,
			));
		if ($r)
		{
			$payment_key = edd_get_payment_key($paymentId);
			$message = sprintf(__("Payment Completed. PaymentId : %s , RefrenceId : %s", 'paystar-card-payment-for-edd'), $paymentId, $p->txn_id);
			edd_update_payment_status($paymentId, 'publish');
			edd_insert_payment_note($paymentId, 'Message : '.esc_html($message));
			edd_insert_payment_note($paymentId, 'PayStarCardObject : '.esc_html(print_r($p,true)));
			edd_insert_payment_note($paymentId, 'ReceivedPost : '.esc_html(print_r($_GET,true)));
			$separator = (parse_url(edd_get_success_page_uri(), PHP_URL_QUERY) == NULL) ? '?' : '&';
			edd_send_to_success_page($separator . 'payment_key=' . $payment_key);
			edd_empty_cart();
		}
		else
		{
			edd_insert_payment_note($paymentId, 'Error : '.esc_html($p->error));
			edd_insert_payment_note($paymentId, 'PayStarCardObject : '.esc_html(print_r($p,true)));
			edd_insert_payment_note($paymentId, 'ReceivedPost : '.esc_html(print_r($_GET,true)));
			edd_update_payment_status($paymentId, 'failed');
			wp_redirect( get_permalink($edd_options['failure_page']) );
			exit;
		}
	}
}
add_action('init', 'edd_gateway_paystar_card_verify');

function edd_gateway_paystar_card_setting($settings)
{
	return array_merge( $settings, array (
				array (
					'id'   => 'paystar_card_setting',
					'name' => __('PayStar Card Setting', 'paystar-card-payment-for-edd'),
					'desc' => __('PayStar Card Setting', 'paystar-card-payment-for-edd'),
					'type' => 'header'
				),
				array (
					'id'   => 'paystar_card_terminal',
					'name' => __('PayStar Card Terminal', 'paystar-card-payment-for-edd'),
					'desc' => __('PayStar Card Terminal', 'paystar-card-payment-for-edd'),
					'type' => 'text',
					'size' => 'regular'
				),
			)
		);
}
add_filter('edd_settings_gateways', 'edd_gateway_paystar_card_setting');

function edd_paystar_card_cc_form_filter(){}
add_filter( 'edd_paystar_card_cc_form', 'edd_paystar_card_cc_form_filter' );

?>